明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1680|回复: 3

图纸插入外部dwg图块的问题

[复制链接]
发表于 2010-11-5 15:08:00 | 显示全部楼层 |阅读模式
    请教各位,如何将外部定义好的dwg图块文件调入到当前文件中?
发表于 2010-11-5 23:28:00 | 显示全部楼层
截取我的trans类的函数,如果想单独使用,要改写下
  1.         public bool GetBlockDefFromFile(string filename, string blkdefname, bool over)
  2.         {
  3.             try
  4.             {
  5.                 bool has = BlockTable.GetRecorId(blkdefname) != ObjectId.Null;
  6.                 if ((has && over) || !has)
  7.                 {
  8.                     using (DBTransaction t = new DBTransaction(filename))
  9.                     {
  10.                         ObjectId id = t.BlockTable.GetRecorId(blkdefname);
  11.                         BlockTableRecord btr = t.GetObject<BlockTableRecord>(id);
  12.                         if (!btr.IsAnonymous && !btr.IsLayout)
  13.                         {
  14.                             t.Database.WblockCloneObjects
  15.                             (
  16.                                 new ObjectIdCollection { id },
  17.                                 Database.BlockTableId,
  18.                                 new IdMapping(),
  19.                                 DuplicateRecordCloning.Replace,
  20.                                 false
  21.                             );
  22.                         }
  23.                     }
  24.                 }
  25.                 return true;
  26.             }
  27.             catch
  28.             { }
  29.             return false;
  30.         }
  31.         public bool GetBlockDefFromFile(string filename, bool over)
  32.         {
  33.             try
  34.             {
  35.                 FileInfo fi = new FileInfo(filename);
  36.                 string blkdefname = fi.Name;
  37.                 if (blkdefname.Contains("."))
  38.                 {
  39.                     blkdefname = blkdefname.Substring(0, blkdefname.LastIndexOf('.'));
  40.                 }
  41.                 bool has = BlockTable.GetRecorId(blkdefname) != ObjectId.Null;
  42.                 if ((has && over) || !has)
  43.                 {
  44.                     Database db = new Database();
  45.                     db.ReadDwgFile(filename, FileShare.Read, true, null);
  46.                     Database.Insert(BlockTableRecord.ModelSpace, blkdefname, db, false);
  47.                 }
  48.                 return true;
  49.             }
  50.             catch
  51.             { }
  52.             return false;
  53.         }
 楼主| 发表于 2010-11-9 10:27:00 | 显示全部楼层

可以实现,谢谢了!

 

发表于 2013-6-22 02:30:56 | 显示全部楼层
好东西,东西好
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 15:54 , Processed in 0.162662 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表